from gi.repository import Gio
from desktop import DesktopParser
from mainwindow import MainWindow
from utils import get_icon, nullstring


class AppGUI:
    """XXX: add docs."""

    def __init__(self):
        """Display the main window."""
        self.gsettings = Gio.Settings('com.canonical.Unity.Launcher')
        self.main_window = MainWindow()
        self.main_window.show()
        self.get_unit_list()
        return

    def get_unit_list(self):
        unity = self.gsettings.get_value('favorites')
        store = self.main_window.listview_launcher.get_model()
        store.clear()
        for menu_item in unity:
            desktop_parser = DesktopParser(menu_item)
            sname = desktop_parser.get('Name')
            icon = desktop_parser.get('Icon')
            if sname is None:
                sname = desktop_parser.get('Name', 'en')
            if icon is None:
                pix = None
            else:
                pix = get_icon(icon)
            store.append((pix, '%s' % sname, desktop_parser, menu_item))
        self.main_window.listview_launcher.set_model(store)
        self.main_window.listview_launcher.connect('cursor-changed',
            self.main_window.listview_launcher_row_change)


